//+------------------------------------------------------------------+
//|                                           Strategy: 23042019.mq4 |
//|                                       Created with EABuilder.com |
//|                                             http://eabuilder.com |
//+------------------------------------------------------------------+
#property copyright "Created with EABuilder.com"
#property link      "http://eabuilder.com"
#property version   "1.00"
#property description ""

#include <stdlib.mqh>
#include <stderror.mqh>

extern int Period1 = 14;
extern int Period1300 = 300;
extern int InpDepth = 12;
extern int InpDepth13 = 13;
extern int InpDepth12 = 12;
extern int InpDeviation5 = 5;
extern int InpBackstep = 3;
extern double Trail_Points = 5;
extern double Trail_Step = 5;
extern int InpDeviation = 5;
extern int InpDepth120 = 12;
extern int InpDeviation500 = 5;
extern int _SL = 20;
extern int _SL21 = 21;
int LotDigits; //initialized in OnInit
extern int MagicNumber = 1408986;
double MM_PositionSizing = 10000;
int MaxSlippage = 3; //adjusted in OnInit
bool Send_Email = true;
bool Audible_Alerts = true;
bool Push_Notifications = true;
int MaxOpenTrades = 1;
int MaxLongTrades = 1;
int MaxShortTrades = 1;
int MaxPendingOrders = 1000;
bool Hedging = true;
int OrderRetry = 5; //# of retries if sending order returns error
int OrderWait = 5; //# of seconds to wait if sending order returns error
double myPoint; //initialized in OnInit

double MM_Size() //position sizing
  {
   double MaxLot = MarketInfo(Symbol(), MODE_MAXLOT);
   double MinLot = MarketInfo(Symbol(), MODE_MINLOT);
   double lots = AccountBalance() / MM_PositionSizing;
   if(lots > MaxLot) lots = MaxLot;
   if(lots < MinLot) lots = MinLot;
   return(lots);
  }

void myAlert(string type, string message)
  {
   int handle;
   if(type == "print")
      Print(message);
   else if(type == "error")
     {
      Print(type+" | 23042019 @ "+Symbol()+","+Period()+" | "+message);
      if(Audible_Alerts) Alert(type+" | 23042019 @ "+Symbol()+","+Period()+" | "+message);
      if(Send_Email) SendMail("23042019", type+" | 23042019 @ "+Symbol()+","+Period()+" | "+message);
      handle = FileOpen("23042019.txt", FILE_TXT|FILE_READ|FILE_WRITE|FILE_SHARE_READ|FILE_SHARE_WRITE, ';');
      if(handle != INVALID_HANDLE)
        {
         FileSeek(handle, 0, SEEK_END);
         FileWrite(handle, type+" | 23042019 @ "+Symbol()+","+Period()+" | "+message);
         FileClose(handle);
        }
      if(Push_Notifications) SendNotification(type+" | 23042019 @ "+Symbol()+","+Period()+" | "+message);
     }
   else if(type == "order")
     {
     }
   else if(type == "modify")
     {
     }
  }

int TradesCount(int type) //returns # of open trades for order type, current symbol and magic number
  {
   int result = 0;
   int total = OrdersTotal();
   for(int i = 0; i < total; i++)
     {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) continue;
      if(OrderMagicNumber() != MagicNumber || OrderSymbol() != Symbol() || OrderType() != type) continue;
      result++;
     }
   return(result);
  }

int myOrderSend(int type, double price, double volume, string ordername) //send order, return ticket ("price" is irrelevant for market orders)
  {
   if(!IsTradeAllowed()) return(-1);
   int ticket = -1;
   int retries = 0;
   int err;
   int long_trades = TradesCount(OP_BUY);
   int short_trades = TradesCount(OP_SELL);
   int long_pending = TradesCount(OP_BUYLIMIT) + TradesCount(OP_BUYSTOP);
   int short_pending = TradesCount(OP_SELLLIMIT) + TradesCount(OP_SELLSTOP);
   string ordername_ = ordername;
   if(ordername != "")
      ordername_ = "("+ordername+")";
   //test Hedging
   if(!Hedging && ((type % 2 == 0 && short_trades + short_pending > 0) || (type % 2 == 1 && long_trades + long_pending > 0)))
     {
      myAlert("print", "Order"+ordername_+" not sent, hedging not allowed");
      return(-1);
     }
   //test maximum trades
   if((type % 2 == 0 && long_trades >= MaxLongTrades)
   || (type % 2 == 1 && short_trades >= MaxShortTrades)
   || (long_trades + short_trades >= MaxOpenTrades)
   || (type > 1 && long_pending + short_pending >= MaxPendingOrders))
     {
      myAlert("print", "Order"+ordername_+" not sent, maximum reached");
      return(-1);
     }
   //prepare to send order
   while(IsTradeContextBusy()) Sleep(100);
   RefreshRates();
   if(type == OP_BUY)
      price = Ask;
   else if(type == OP_SELL)
      price = Bid;
   else if(price < 0) //invalid price for pending order
     {
      myAlert("order", "Order"+ordername_+" not sent, invalid price for pending order");
	  return(-1);
     }
   int clr = (type % 2 == 1) ? clrRed : clrBlue;
   while(ticket < 0 && retries < OrderRetry+1)
     {
      ticket = OrderSend(Symbol(), type, NormalizeDouble(volume, LotDigits), NormalizeDouble(price, Digits()), MaxSlippage, 0, 0, ordername, MagicNumber, 0, clr);
      if(ticket < 0)
        {
         err = GetLastError();
         myAlert("print", "OrderSend"+ordername_+" error #"+err+" "+ErrorDescription(err));
         Sleep(OrderWait*1000);
        }
      retries++;
     }
   if(ticket < 0)
     {
      myAlert("error", "OrderSend"+ordername_+" failed "+(OrderRetry+1)+" times; error #"+err+" "+ErrorDescription(err));
      return(-1);
     }
   string typestr[6] = {"Buy", "Sell", "Buy Limit", "Sell Limit", "Buy Stop", "Sell Stop"};
   myAlert("order", "Order sent"+ordername_+": "+typestr[type]+" "+Symbol()+" Magic #"+MagicNumber);
   return(ticket);
  }

void myOrderDelete(int type, string ordername) //delete pending orders of "type"
  {
   if(!IsTradeAllowed()) return;
   bool success = false;
   int err;
   string ordername_ = ordername;
   if(ordername != "")
      ordername_ = "("+ordername+")";
   int total = OrdersTotal();
   for(int i = total-1; i >= 0; i--)
     {
      while(IsTradeContextBusy()) Sleep(100);
      if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderMagicNumber() != MagicNumber || OrderSymbol() != Symbol() || OrderType() != type) continue;
      while(IsTradeContextBusy()) Sleep(100);
      RefreshRates();
      success = OrderDelete(OrderTicket());
      if(!success)
        {
         err = GetLastError();
         myAlert("error", "OrderDelete"+ordername_+" failed; error #"+err+" "+ErrorDescription(err));
        }
     }
   string typestr[6] = {"Buy", "Sell", "Buy Limit", "Sell Limit", "Buy Stop", "Sell Stop"};
   if(success) myAlert("order", "Orders deleted"+ordername_+": "+typestr[type]+" "+Symbol()+" Magic #"+MagicNumber);
  }

int myOrderModify(int ticket, double SL, double TP) //modify SL and TP (absolute price), zero targets do not modify
  {
   if(!IsTradeAllowed()) return(-1);
   bool success = false;
   int retries = 0;
   int err;
   SL = NormalizeDouble(SL, Digits());
   TP = NormalizeDouble(TP, Digits());
   if(SL < 0) SL = 0;
   if(TP < 0) TP = 0;
   //prepare to select order
   while(IsTradeContextBusy()) Sleep(100);
   if(!OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
     {
      err = GetLastError();
      myAlert("error", "OrderSelect failed; error #"+err+" "+ErrorDescription(err));
      return(-1);
     }
   //prepare to modify order
   while(IsTradeContextBusy()) Sleep(100);
   RefreshRates();
   if(CompareDoubles(SL, 0)) SL = OrderStopLoss(); //not to modify
   if(CompareDoubles(TP, 0)) TP = OrderTakeProfit(); //not to modify
   if(CompareDoubles(SL, OrderStopLoss()) && CompareDoubles(TP, OrderTakeProfit())) return(0); //nothing to do
   while(!success && retries < OrderRetry+1)
     {
      success = OrderModify(ticket, NormalizeDouble(OrderOpenPrice(), Digits()), NormalizeDouble(SL, Digits()), NormalizeDouble(TP, Digits()), OrderExpiration(), CLR_NONE);
      if(!success)
        {
         err = GetLastError();
         myAlert("print", "OrderModify error #"+err+" "+ErrorDescription(err));
         Sleep(OrderWait*1000);
        }
      retries++;
     }
   if(!success)
     {
      myAlert("error", "OrderModify failed "+(OrderRetry+1)+" times; error #"+err+" "+ErrorDescription(err));
      return(-1);
     }
   string alertstr = "Order modified: ticket="+ticket;
   if(!CompareDoubles(SL, 0)) alertstr = alertstr+" SL="+SL;
   if(!CompareDoubles(TP, 0)) alertstr = alertstr+" TP="+TP;
   myAlert("modify", alertstr);
   return(0);
  }

void TrailingStopTrail(int type, double TS, double step, bool aboveBE) //set Stop Loss to "TS" if price is going your way with "step"
  {
   int total = OrdersTotal();
   TS = NormalizeDouble(TS, Digits());
   step = NormalizeDouble(step, Digits());
   for(int i = total-1; i >= 0; i--)
     {
      while(IsTradeContextBusy()) Sleep(100);
      if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderMagicNumber() != MagicNumber || OrderSymbol() != Symbol() || OrderType() != type) continue;
	  RefreshRates();
      if(type == OP_BUY && (!aboveBE || Bid > OrderOpenPrice() + TS) && (NormalizeDouble(OrderStopLoss(), Digits()) <= 0 || Bid > OrderStopLoss() + TS + step))
         myOrderModify(OrderTicket(), Bid - TS, 0);
      else if(type == OP_SELL && (!aboveBE || Ask < OrderOpenPrice() - TS) && (NormalizeDouble(OrderStopLoss(), Digits()) <= 0 || Ask < OrderStopLoss() - TS - step))
         myOrderModify(OrderTicket(), Ask + TS, 0);
     }
  }

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {   
   //initialize myPoint
   myPoint = Point();
   if(Digits() == 5 || Digits() == 3)
     {
      myPoint *= 10;
      MaxSlippage *= 10;
     }
   //initialize LotDigits
   double LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
   if(LotStep >= 1) LotDigits = 0;
   else if(LotStep >= 0.1) LotDigits = 1;
   else if(LotStep >= 0.01) LotDigits = 2;
   else LotDigits = 3;
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  }

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   int ticket = -1;
   double price;   
   double TP;
   
   TrailingStopTrail(OP_BUY, Trail_Points * myPoint, Trail_Step * myPoint, true); //Trailing Stop = trail
   TrailingStopTrail(OP_SELL, Trail_Points * myPoint, Trail_Step * myPoint, true); //Trailing Stop = trail
   
   //Delete Pending Buy Orders
   if(iCustom(NULL, PERIOD_D1, "ZigZag", 12, 5, 3, 0, 0) > iCustom(NULL, PERIOD_D1, "ZigZag", 13, 5, 3, 0, 0) //ZigZag > ZigZag
   && iCustom(NULL, PERIOD_D1, "RSI_FWA", 14, 5, 72, 28, 0, 0) > iCustom(NULL, PERIOD_D1, "RSI_FWA", 15, 5, 72, 28, 0, 0) //RSI_FWA > RSI_FWA
   && iCustom(NULL, PERIOD_D1, "RSI_vs_BB", 14, 70, 30, 20, 2, true, true, true, true, clrYellow, 0, 0) > iCustom(NULL, PERIOD_D1, "RSI_vs_BB", 15, 70, 30, 20, 2, true, true, true, true, clrYellow, 0, 0) //RSI_vs_BB > RSI_vs_BB
   && iCustom(NULL, PERIOD_D1, "Reverse Day Fractal", 0.01, 20, 10, 6789, 25, 5, "Fractal BOT", 3, true, true, 0) > iCustom(NULL, PERIOD_D1, "Reverse Day Fractal", 0.01, 21, 10, 6789, 25, 5, "Fractal BOT", 3, true, true, 0) //Reverse Day Fractal > Reverse Day Fractal
   && iCustom(NULL, PERIOD_D1, "reverseall_v2_9 (1)", false, 0, 0) > iCustom(NULL, PERIOD_D1, "reverseall_v2_9 (1)", false, 0, 0) //reverseall_v2_9 (1) > reverseall_v2_9 (1)
   )
     {   
      if(IsTradeAllowed())
         myOrderDelete(OP_BUYSTOP, "");
      else //not autotrading => only send alert
         myAlert("order", "");
     }
   
   //Delete Pending Sell Orders
   if(iCustom(NULL, PERIOD_D1, "ZigZag", 12, 5, 3, 0, 0) < iCustom(NULL, PERIOD_D1, "ZigZag", 13, 5, 3, 0, 0) //ZigZag < ZigZag
   && iCustom(NULL, PERIOD_D1, "RSI_FWA", 14, 5, 72, 28, 0, 0) < iCustom(NULL, PERIOD_D1, "RSI_FWA", 15, 5, 72, 28, 0, 0) //RSI_FWA < RSI_FWA
   && iCustom(NULL, PERIOD_D1, "RSI_vs_BB", 14, 70, 30, 20, 2, true, true, true, true, clrYellow, 0, 0) < iCustom(NULL, PERIOD_D1, "RSI_vs_BB", 15, 70, 30, 20, 2, true, true, true, true, clrYellow, 0, 0) //RSI_vs_BB < RSI_vs_BB
   && iCustom(NULL, PERIOD_D1, "Reverse Day Fractal", 0.01, 20, 10, 6789, 25, 5, "Fractal BOT", 3, true, true, 0) < iCustom(NULL, PERIOD_D1, "Reverse Day Fractal", 0.01, 21, 10, 6789, 25, 5, "Fractal BOT", 3, true, true, 0) //Reverse Day Fractal < Reverse Day Fractal
   && iCustom(NULL, PERIOD_D1, "reverseall_v2_9 (1)", false, 0, 0) < iCustom(NULL, PERIOD_D1, "reverseall_v2_9 (1)", false, 0, 0) //reverseall_v2_9 (1) < reverseall_v2_9 (1)
   )
     {   
      if(IsTradeAllowed())
         myOrderDelete(OP_SELLSTOP, "");
      else //not autotrading => only send alert
         myAlert("order", "");
     }
   
   //Open Buy Order
   if(iATR(NULL, PERIOD_D1, Period1, 0) < iATR(NULL, PERIOD_D1, Period1300, 0) //Average True Range < Average True Range
   )
     {
      RefreshRates();
      price = Ask;
      TP = iCustom(NULL, PERIOD_D1, "ZigZag", InpDepth12, InpDeviation5, InpBackstep, 0, 0); //Take Profit = ZigZag   
      if(IsTradeAllowed())
        {
         ticket = myOrderSend(OP_BUY, price, MM_Size(), "");
         if(ticket <= 0) return;
        }
      else //not autotrading => only send alert
         myAlert("order", "");
      myOrderModify(ticket, 0, TP);
     }
   
   //Open Sell Order
   if(iATR(NULL, PERIOD_D1, Period1, 0) > iATR(NULL, PERIOD_D1, Period1300, 0) //Average True Range > Average True Range
   )
     {
      RefreshRates();
      price = Bid;
      TP = iCustom(NULL, PERIOD_D1, "ZigZag", InpDepth12, InpDeviation5, InpBackstep, 0, 0); //Take Profit = ZigZag   
      if(IsTradeAllowed())
        {
         ticket = myOrderSend(OP_SELL, price, MM_Size(), "");
         if(ticket <= 0) return;
        }
      else //not autotrading => only send alert
         myAlert("order", "");
      myOrderModify(ticket, 0, TP);
     }
  }
//+------------------------------------------------------------------+